## golang-github-pingcap-kvproto 6.1.0~alpha

=== Makefile ===
### Makefile for kvproto

CURDIR := $(shell pwd)

export PATH := $(CURDIR)/bin/:$(PATH)

all: go rust c++

init:
	mkdir -p $(CURDIR)/bin
check: init
	$(CURDIR)/scripts/check.sh
go: check
	# Standalone GOPATH
	$(CURDIR)/scripts/generate_go.sh
	GO111MODULE=on go mod tidy
	GO111MODULE=on go build ./pkg/...

rust: init
	cargo check && \
	cargo check --no-default-features --features prost-codec

c++: check
	mkdir -p kvprotobuild && cd kvprotobuild && cmake ../cpp -DCMAKE_PREFIX_PATH=$$GRPC_INSTALL_PATH && make

.PHONY: all

=== cpp/CMakeLists.txt ===
project (kvproto)

cmake_minimum_required (VERSION 2.8.12)

set (CMAKE_CXX_STANDARD 17)

if (CMAKE_VERSION VERSION_LESS "3.8.0")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1z")
else ()
    set (CMAKE_CXX_STANDARD 17)
    set (CMAKE_CXX_EXTENSIONS 1) # https://cmake.org/cmake/help/latest/prop_tgt/CXX_EXTENSIONS.html#prop_tgt:CXX_EXTENSIONS
    set (CMAKE_CXX_STANDARD_REQUIRED ON)
endif ()

set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

if (NOT Protobuf_INCLUDE_DIR)
    include (cmake/find_protobuf.cmake)
endif ()

if (NOT gRPC_FOUND)
    include (cmake/find_grpc.cmake)
endif ()

# .proto files under "proto"
set (PROTO_DEF_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../proto")
file (GLOB PROTO_DEFS "${PROTO_DEF_DIR}/*.proto")
# .proto files under "include"
set (PROTO_INC_DEF_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../include")
get_filename_component (PROTO_INC_DEF_DIR ${PROTO_INC_DEF_DIR} ABSOLUTE)
file (GLOB PROTO_INC_DEFS "${PROTO_INC_DEF_DIR}/*.proto")
list (APPEND PROTO_INC_DEFS
    "${PROTO_INC_DEF_DIR}/google/api/http.proto"
    "${PROTO_INC_DEF_DIR}/google/api/annotations.proto"
)
# The output dir for .pb.h, .pb.cc
set (PROTO_OUTPUT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/kvproto")
file (MAKE_DIRECTORY "${PROTO_OUTPUT_DIR}")
# A temporary directory for proto file without gogoproto marks
set (PROTO_DEF_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/protos")
file (MAKE_DIRECTORY "${PROTO_DEF_TMP_DIR}")

set (CLEAN_PROTO_DEFS "")
foreach (F ${PROTO_DEFS})
    get_filename_component (ABS_FIL ${F} ABSOLUTE)
    get_filename_component (FIL_WE ${F} NAME_WE)
    list (APPEND CLEAN_PROTO_DEFS "${PROTO_DEF_TMP_DIR}/${FIL_WE}.proto")
    # Generate a output file by copying and cleaning up gogoproto marks.
    # Will be re-generated if the original .proto file is changed.
    add_custom_command(
        OUTPUT "${PROTO_DEF_TMP_DIR}/${FIL_WE}.proto"
        WORKING_DIRECTORY ${PROTO_DEF_DIR}
        COMMAND cp ${ABS_FIL} ${PROTO_DEF_TMP_DIR}/${FIL_WE}.proto
        COMMAND bash -c "source ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/common.sh && clean_gogo_proto ${PROTO_DEF_TMP_DIR}/${FIL_WE}.proto"
        DEPENDS ${ABS_FIL}
        COMMENT "Generating clean proto file on ${ABS_FIL}"
        VERBATIM)
endforeach()
# Grab all clean .proto files as a target
add_custom_target (__clean_kvproto_defs
    DEPENDS ${CLEAN_PROTO_DEFS}
    VERBATIM)

set (PROTO_SRCS "")
set (PROTO_HDRS "")
foreach (F ${PROTO_INC_DEFS}) # .proto under "include"
    get_filename_component (ABS_FIL ${F} ABSOLUTE)
    # We need relative path for .proto under subdirectory
    string(REPLACE "${PROTO_INC_DEF_DIR}/" "" RELA_FIL ${ABS_FIL})
    string(REPLACE ".proto" ".pb.cc" PROTO_SRC ${RELA_FIL})
    string(REPLACE ".proto" ".pb.h" PROTO_HDR ${RELA_FIL})

    # message(STATUS "${F} ${ABS_FIL} ${RELA_FIL}")
    list (APPEND PROTO_SRCS "${PROTO_OUTPUT_DIR}/${PROTO_SRC}")
    list (APPEND PROTO_HDRS "${PROTO_OUTPUT_DIR}/${PROTO_HDR}")
    # Create the generated cpp files for .proto file.
    # Add dependency on the original .proto file
    # so that it can re-generate source files if .proto changed.
    add_custom_command(
        OUTPUT "${PROTO_OUTPUT_DIR}/${PROTO_SRC}"
               "${PROTO_OUTPUT_DIR}/${PROTO_HDR}"
        WORKING_DIRECTORY ${PROTO_INC_DEF_DIR}
        COMMAND ${Protobuf_PROTOC_EXECUTABLE}
        ARGS --cpp_out=${PROTO_OUTPUT_DIR} -I=${PROTO_DEF_TMP_DIR}:${PROTO_INC_DEF_DIR} ${RELA_FIL}
        DEPENDS ${ABS_FIL} ${Protobuf_PROTOC_EXECUTABLE} __clean_kvproto_defs
        COMMENT "Running C++ protocol buffer compiler on ${ABS_FIL}"
        VERBATIM)
endforeach() # end for .proto under "include"
foreach (F ${PROTO_DEFS}) # .proto under "proto"
    get_filename_component (ABS_FIL ${F} ABSOLUTE)
    get_filename_component (FIL_WE ${F} NAME_WE)

    # message(STATUS "${F} ${ABS_FIL}")
    list (APPEND PROTO_SRCS "${PROTO_OUTPUT_DIR}/${FIL_WE}.pb.cc")
    list (APPEND PROTO_HDRS "${PROTO_OUTPUT_DIR}/${FIL_WE}.pb.h")
    # Need to appen grpc services files
    list (APPEND PROTO_SRCS "${PROTO_OUTPUT_DIR}/${FIL_WE}.grpc.pb.cc")
    list (APPEND PROTO_HDRS "${PROTO_OUTPUT_DIR}/${FIL_WE}.grpc.pb.h")
    # Create the generated cpp files for .proto file.
    # Add dependency on the original .proto file and `__clean_kvproto_defs`
    # so that it can re-generate source files if .proto changed.
    add_custom_command(
        OUTPUT "${PROTO_OUTPUT_DIR}/${FIL_WE}.pb.cc"
               "${PROTO_OUTPUT_DIR}/${FIL_WE}.pb.h"
        WORKING_DIRECTORY ${PROTO_DEF_TMP_DIR}
        COMMAND ${Protobuf_PROTOC_EXECUTABLE}
        ARGS --cpp_out=${PROTO_OUTPUT_DIR} -I=${PROTO_DEF_TMP_DIR}:${PROTO_INC_DEF_DIR} ${PROTO_DEF_TMP_DIR}/${FIL_WE}.proto 
        # And also grpc service
        COMMAND ${Protobuf_PROTOC_EXECUTABLE}
        ARGS --grpc_out=${PROTO_OUTPUT_DIR} -I=${PROTO_DEF_TMP_DIR}:${PROTO_INC_DEF_DIR}  --plugin=protoc-gen-grpc=${gRPC_CPP_PLUGIN} ${PROTO_DEF_TMP_DIR}/${FIL_WE}.proto
        DEPENDS ${ABS_FIL} ${Protobuf_PROTOC_EXECUTABLE} ${gRPC_CPP_PLUGIN} __clean_kvproto_defs
        COMMENT "Running C++ protocol buffer compiler on ${ABS_FIL}"
        VERBATIM)
endforeach() # end for .proto under "proto"

# Mark those clean .proto, .pb.h, .pb.cc files are generated
# so that they can be re-build if changed and clean by `make clean`
set_source_files_properties(
    ${CLEAN_PROTO_DEFS} ${PROTO_SRCS} ${PROTO_HDRS}
    PROPERTIES GENERATED TRUE
)

add_library(kvproto
    ${PROTO_SRCS} ${PROTO_HDRS}
)
target_include_directories(kvproto
    PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/kvproto
    ${Protobuf_INCLUDE_DIR}
    ${gRPC_INCLUDE_DIRS}
)

=== debian/changelog ===
golang-github-pingcap-kvproto (6.1.0~alpha-1) unstable; urgency=medium

  * Initial release (Closes: #1107496)

 -- Otto Kekäläinen <otto@debian.org>  Thu, 05 Jun 2025 12:39:19 +0000

=== debian/control ===
Source: golang-github-pingcap-kvproto
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Otto Kekäläinen <otto@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-grpc-ecosystem-grpc-gateway-dev,
 golang-gogoprotobuf-dev,
 golang-google-genproto-dev,
 golang-google-grpc-dev,
 golang-goprotobuf-dev,
 protobuf-compiler,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-pingcap-kvproto
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-pingcap-kvproto.git
Homepage: https://github.com/pingcap/kvproto
XS-Go-Import-Path: github.com/pingcap/kvproto

Package: golang-github-pingcap-kvproto-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-grpc-ecosystem-grpc-gateway-dev,
 golang-gogoprotobuf-dev,
 golang-google-genproto-dev,
 golang-google-grpc-dev,
 golang-goprotobuf-dev,
 ${misc:Depends},
Description: Protocol buffer definitions for the TiKV project
 TiKV is a distributed, transactional key-value database. This package
 contains the Go source code generated from the protocol buffer
 definitions that are used for communication between TiKV servers and
 clients.

=== debian/rules ===
#!/usr/bin/make -f

export GOPATH ?= $(CURDIR)/debian/go
export PATH := $(GOPATH)/bin:$(PATH)

override_dh_auto_build:
	# The grpc-gateway definitions have been removed from the proto files
	# to fix the build with grpc-gateway v2.
	# Remove the stale generated gateway file.
	rm -f pkg/configpb/configpb.pb.gw.go
	# Regenerate the main pb.go file from the patched proto file.
	# The paths=source_relative option with protoc is tricky. We generate
	# the file in a temporary location and move it.
	# Remove rust-specific lines that break gogo
	sed -i '/rustproto/d' proto/configpb.proto
	# But we still need to generate rustproto itself, because other protos may depend on it.
	# Use a temp dir and move to avoid creating nested directories on re-runs.
	mkdir -p debian/.build/proto-gen
	protoc -I. -Iinclude --gogo_out=paths=source_relative,Mgoogle/protobuf/descriptor.proto=github.com/gogo/protobuf/protoc-gen-gogo/descriptor:debian/.build/proto-gen include/rustproto.proto
	rm -f pkg/rustproto/rustproto.pb.go
	mkdir -p pkg/rustproto
	mv debian/.build/proto-gen/include/rustproto.pb.go pkg/rustproto/
	mkdir -p debian/.build/proto-gen
	protoc -I. -Iinclude --gogo_out=plugins=grpc,paths=source_relative:debian/.build/proto-gen proto/configpb.proto
	mkdir -p pkg/configpb
	mv debian/.build/proto-gen/proto/configpb.pb.go pkg/configpb/
	dh_auto_build

%:
	dh $@ --builddirectory=debian/.build/upstream --buildsystem=golang

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/pingcap/kvproto/tags .*/v?(\d\S*)\.tar\.gz debian
